///////////////////////////////////////////////////////////////////////////////
//
//  xamlitem.js
//
//
//  2007 Microsoft Corporation. All Rights Reserved.
//
// This file is licensed as part of the Silverlight 1.0 SDK, for details look
// here: http://go.microsoft.com/fwlink/?LinkID=89144&clcid=0x409
//
///////////////////////////////////////////////////////////////////////////////
function xamlItem(target, index) {
	this.target = target;
	this.index = index;
	this.xaml = null;
	this.clickHandler = null;
	this.xamlUrl = this.target.findName("itemXaml" + this.index.toString()).text;
	target.addEventListener("mouseEnter", delegate(this, this.handleMouseEnter));
	target.addEventListener("mouseLeave", delegate(this, this.handleMouseLeave));
	target.addEventListener("mouseLeftButtonUp", delegate(this, this.handleClick));
    target.addEventListener("mouseLeftButtonDown", delegate(this, this.handleMouseDown));
}

xamlItem.prototype.handleMouseEnter = function(sender, eventArgs) {
	var itemBackground = this.target.findName("itemBackground" + this.index.toString());
	itemBackground.fill = "#FF626262";
}

xamlItem.prototype.handleMouseLeave = function(sender, eventArgs) {
	var itemBackground = this.target.findName("itemBackground" + this.index.toString());
	itemBackground.fill = "#FF424242";
}

xamlItem.prototype.handleClick = function(sender, eventArgs) {
	var itemBackground = this.target.findName("itemBackground" + this.index.toString());
	itemBackground.fill = "#FF626262";
	
	if (this.clickHandler != null) {
	    this.clickHandler(this);
	}
}

xamlItem.prototype.handleMouseDown = function(sender, eventArgs) {
	var itemBackground = this.target.findName("itemBackground" + this.index.toString());
	itemBackground.fill = "#FF222222";
}